from faker import Faker
from backend.database import async_session_maker
import backend.models as models


class Crud:
    @staticmethod
    async def insert_demo_data():
        async with async_session_maker() as session:
            fake = Faker(["ru_RU"])

            all_role = [
                models.Role(role="admin"),
                models.Role(role="director"),
                models.Role(role="worker"),
                models.Role(role="client"),
            ]

            session.add_all(all_role)
            await session.flush()

            admin = models.User(
                email="admin@mail.com",
                hashed_password="admin",
                is_active=True,
                is_superuser=True,
                is_verified=True,
                roles=all_role,
            )

            director = models.User(
                name=fake.first_name_male(),
                email="director@mail.com",
                hashed_password="director",
                roles=all_role[1:3],
            )

            worker1 = models.User(
                email="worker1@mail.com",
                hashed_password="worker1",
                roles=all_role[2:3],
            )
            worker2 = models.User(
                email="worker2@mail.com",
                hashed_password="worker2",
                roles=all_role[2:3],
            )
            client1 = models.User(
                email="client1@mail.com",
                hashed_password="client1",
                roles=all_role[3:],
            )
            client2 = models.User(
                email="client2@mail.com",
                hashed_password="client2",
                roles=all_role[3:],
            )
            client3 = models.User(
                email="client3@mail.com",
                hashed_password="client3",
                roles=all_role[3:],
            )

            for _ in range(10):
                print(fake.address())

            session.add_all(
                [
                    admin,
                    director,
                    worker1,
                    worker2,
                    client1,
                    client2,
                    client3,
                ]
            )
            await session.commit()
